#define BRIGHTNESS 0.05 //-0.03
#define CONTRAST 2.0
#define DESATURATION 0.4
#define DUST float4(0.5,0.5,0.2, 0.5) //0.85,0.7,0.4, 1.0

#define X_OFFSET 0.5
#define Z_OFFSET 0.5


texture tex0 < string ResourceName = "Base.tga"; >;		// Base texture
texture tex1 < string ResourceName = "Terrain.tga"; >;	// Terrain texture
texture tex2 < string ResourceName = "Color.dds"; >;		// Color texture
texture tex3 < string ResourceName = "Alpha.dds"; >;		// Terrain Alpha Mask
texture tex4 < string ResourceName = "BorderDirection.dds"; >;	// Borders texture
texture tex5 < string ResourceName = "ProvinceBorders.dds"; >;
texture tex6 < string ResourceName = "CountryBorders.dds"; >;
texture tex7 < string ResourceName = "TerraIncog.dds"; >;


float4x4 WorldMatrix		: World; 
float4x4 ViewMatrix		: View; 
float4x4 ProjectionMatrix	: Projection; 
float4x4 AbsoluteWorldMatrix;
float3	 LightDirection;
float	 vAlpha;

sampler BaseTexture  =
sampler_state
{
    Texture = <tex0>;
    MinFilter = Linear; //Point;
    MagFilter = Linear; //Point;
    MipFilter = Linear; //None;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler TreeTexture  =
sampler_state
{
    Texture = <tex0>;
    MinFilter = Linear; //Point;
    MagFilter = Linear; //Point;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};


sampler MapTexture  =
sampler_state
{
    Texture = <tex1>;
    MinFilter = Linear; //Point;
    MagFilter = Linear; //Point;
    MipFilter = Linear; //None;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler StripesTexture  =
sampler_state
{
    Texture = <tex1>;
    MinFilter = Linear; //Point;
    MagFilter = Linear; //Point;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};


sampler ColorTexture  =
sampler_state
{
    Texture = <tex4>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};

// used for political, religious etc etc..
sampler GeneralTexture  =
sampler_state
{
    Texture = <tex2>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler GeneralTexture2  =
sampler_state
{
    Texture = <tex3>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};


sampler TerrainAlphaTexture  =
sampler_state
{
    Texture = <tex3>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler BorderDirectionTexture  =
sampler_state
{
    Texture = <tex4>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler WinterTexture  =
sampler_state
{
    Texture = <tex2>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};


sampler ProvinceBorderTexture  =
sampler_state
{
    Texture = <tex5>;
    MinFilter = Point; //Linear;
    MagFilter = Point; //Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler CountryBorderTexture  =
sampler_state
{
    Texture = <tex6>;
    MinFilter = Point; //Linear;
    MagFilter = Point; //Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler BorderDiagTexture  =
sampler_state
{
    Texture = <tex1>;
    MinFilter = Point; //Linear;
    MagFilter = Point; //Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};


sampler TerraIncognitaTextureTerrain =
sampler_state
{
    Texture = <tex7>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler TerraIncognitaTextureTree =
sampler_state
{
    Texture = <tex1>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};


struct VS_INPUT
{
    float4 vPosition  : POSITION;
    float3 vNormal    : NORMAL;
    float2 vTexCoord  : TEXCOORD0;
    float2 vProvinceIndexCoord  : TEXCOORD1;
};

struct VS_INPUT_BEACH
{
    float4 vPosition  : POSITION;
    float3 vNormal    : NORMAL;

    float2 vProvinceIndexCoord  : TEXCOORD0;
};

struct VS_OUTPUT
{
    float4  vPosition : POSITION;
    float4  vTexCoord0 : TEXCOORD0;	// third beein' lightIntensity, 4th height
    float2  vTexCoord1 : TEXCOORD1;
    float2  vColorTexCoord : TEXCOORD2;

    float2  vBorderTexCoord0 : TEXCOORD3;
    float2  vBorderTexCoord1 : TEXCOORD4;

    float2  vTerrainTexCoord : TEXCOORD5;

    float2 vProvinceIndexCoord  : TEXCOORD6;

    float4 General		: TEXCOORD7; //n


};

struct VS_OUTPUT_BEACH
{
    float4  vPosition : POSITION;
    float2  vTexCoordBase : TEXCOORD0;
    float2  vColorTexCoord : TEXCOORD1;
	// Later put this into ONE texcoord, this is easier for debugging etc..
    float3  vLightIntensity : TEXCOORD2;
    float2 vProvinceIndexCoord  : TEXCOORD3;
	float2 vBorderTexCoord0		: TEXCOORD4;
};

struct VS_INPUT_PTI
{
    float4 vPosition  : POSITION;
};

struct VS_OUTPUT_PTI
{
    float4  vPosition : POSITION;
};


struct VS_INPUT_TREE
{
    float4 vPosition : POSITION;
    float2 vTexCoord : TEXCOORD0;
};

struct VS_OUTPUT_TREE
{
    float4 vPosition   : POSITION;
    float2 vTexCoord   : TEXCOORD0;
    float2 vTexCoordTI : TEXCOORD1;
};

/////////////////////////////////////////////////////////////////////////////////



VS_OUTPUT VertexShader_Map_General(const VS_INPUT v )
{ //test11 political map hieght etc
	VS_OUTPUT Out = (VS_OUTPUT)0;

	float4 pos = v.vPosition;
	pos.y = min(pos.y, 0.29);

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul( pos, (float4x3)WorldView);
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	float3 VertexNormal = mul( v.vNormal, WorldMatrix );
	float3 direction = normalize( LightDirection );
	Out.vTexCoord0.z = max( dot( VertexNormal, -direction ), 0.5f );

	Out.vProvinceIndexCoord = v.vProvinceIndexCoord;

	float4 WorldPosition = mul( pos, AbsoluteWorldMatrix );

	float2 TerrainCoord = WorldPosition.xz;
	TerrainCoord += 0.5;
	TerrainCoord /= 8.0;
	Out.vTerrainTexCoord  = 0.5*TerrainCoord;

	Out.vBorderTexCoord0 = float2( WorldPosition.x/2048.0f, WorldPosition.z/1024.0f );

	//Out.vTexCoord0.z = saturate(3*mul( float3(0,1,0) , (float4x3)WorldView).y-0.2); //zoom removed after beta
	
	return Out;
}



float4 PixelShader_Map2_0_General( VS_OUTPUT v ) : COLOR
{  //beaches and TI and splotchyness
	float4 noise = tex2D( BaseTexture, v.vTerrainTexCoord );
	float4 Color1 = tex2D( GeneralTexture, v.vProvinceIndexCoord );
	float4 Color2 = tex2D( GeneralTexture2, v.vProvinceIndexCoord );

	float vColor = tex2D( StripesTexture, v.vTerrainTexCoord ).a;
	float4 Color = lerp(Color1, Color2, vColor);
			
  	float4 WorldColor = tex2D( ColorTexture, v.vBorderTexCoord0 );
  
  	float4 OutColor = float4(1.0,1.0,1.0,1.0); 

	if (WorldColor.r > 0.7) noise.g = 0.0;
	if (WorldColor.r < 0.3 && WorldColor.g > (0.5+0.5*noise.r)) OutColor.rgb = lerp(1.0, float3(0.55, 0.8, 0.55), v.vTexCoord0.z*(1-noise.b));	

	OutColor.rgb += 1.5*Color.rgb - 0.5;
	OutColor.rgb *= 0.5;

	return OutColor;
}

VS_OUTPUT_BEACH VertexShader_Beach_General(const VS_INPUT_BEACH v )
{ //test4 might change political textures
	VS_OUTPUT_BEACH Out = (VS_OUTPUT_BEACH)0;

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	
	float4 pos = v.vPosition;
	pos.y =min(pos.y, 0.29);
	
	float3 P = mul(pos, (float4x3)WorldView);
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	float3 VertexNormal = mul( v.vNormal, WorldMatrix );

	float3 direction = normalize( LightDirection );
	Out.vLightIntensity.xy = max( dot( VertexNormal, -direction ), 0.5f );

	Out.vProvinceIndexCoord = v.vProvinceIndexCoord;

	float4 WorldPosition = mul( pos, AbsoluteWorldMatrix );
	Out.vColorTexCoord.xy = float2( WorldPosition.x/2048.0f, WorldPosition.z/1024.0f );

	float2 TerrainCoord = WorldPosition.xz;
	TerrainCoord += 0.5;
	TerrainCoord /= 8.0;
	Out.vTexCoordBase  = TerrainCoord;

	Out.vBorderTexCoord0 = float2( WorldPosition.x/2048.0f, WorldPosition.z/1024.0f );

	return Out;
}


float4 PixelShader_Beach_General( VS_OUTPUT_BEACH v ) : COLOR
{ //test5 political TI
	float4 BaseColor = tex2D( BaseTexture, v.vTexCoordBase );
	float4 Color = tex2D( GeneralTexture, v.vProvinceIndexCoord ) ;

	float4 OutColor = float4(1.0,1.0,1.0,1.0); // BaseColor.gggg;

	OutColor.rgb += 1.5*Color.rgb - 0.5;
	OutColor.rgb *= 0.5;

	return OutColor;
}
	
/////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT VertexShader_Map_Border(const VS_INPUT v )
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	float4 pos = v.vPosition;
	pos.y = min(pos.y, 0.32);
	//pos.y = min(pos.y, 0.29);

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul(pos, (float4x3)WorldView);
	//float3 P = mul(v.vPosition, (float4x3)WorldView);
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	float4 WorldPosition = mul( v.vPosition, AbsoluteWorldMatrix );

	float2 TerrainCoord = WorldPosition.xz;
	TerrainCoord += 0.5;
	TerrainCoord /= 8.0;
	Out.vTerrainTexCoord  = TerrainCoord;

	Out.vBorderTexCoord0 = float2( ( WorldPosition.x + 0.5 )/2048.0f, ( WorldPosition.z + 0.5 ) /1024.0f );
	Out.vBorderTexCoord1 = float2( WorldPosition.x, WorldPosition.z );

	return Out;
}


float4 PixelShader_Map2_0_Border( VS_OUTPUT v ) : COLOR
{ //test6 border color
	
	float4 BorderDirectionColor = tex2D( BorderDirectionTexture, v.vBorderTexCoord0 );
	float2 TexCoord = v.vBorderTexCoord1;

	TexCoord += 0.5;

	TexCoord %= 1;				// 0 => 1 range.. only thing we need is the decimal part.
	TexCoord.y = 1.0 - TexCoord.y;
	TexCoord.x /= 16;
	TexCoord.x *= 0.8; //75;
	float2 TexCoord2 = TexCoord;
	float2 TexCoord3 = TexCoord;

	TexCoord.x += BorderDirectionColor.b;
	float4 ProvinceBorder = tex2D( ProvinceBorderTexture, TexCoord );

	TexCoord2.x += BorderDirectionColor.r;
	float4 CountryBorder = tex2D( CountryBorderTexture, TexCoord2 );

	TexCoord3.x += BorderDirectionColor.a;
	float4 DiagBorder = tex2D( BorderDiagTexture, TexCoord3 );

	float4 OutColor;
	OutColor.a = max( ProvinceBorder.a, CountryBorder.a );
	OutColor.a = max( OutColor.a, DiagBorder.a );

	OutColor.rgb = float3(0.4,0.2,0.05);

	// Terra incognita
	float TerraIncognita = tex2D( TerraIncognitaTextureTerrain, v.vBorderTexCoord0 ).g;
	if (TerraIncognita < 0.25) 
	OutColor.rgb = lerp(0.55*DUST.rgb,OutColor.rgb, saturate(20*(TerraIncognita - 0.0)));
	else  OutColor.a = lerp(OutColor.a,0.0, saturate(5 * 4 *(TerraIncognita-0.25)/3));

	return OutColor;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT VertexShader_Map(const VS_INPUT v )
{  //test7 terrain mapmode or terrain map
	VS_OUTPUT Out = (VS_OUTPUT)0;

	float4 pos = v.vPosition;
	pos.y = min(pos.y, 0.29);

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul(pos, (float4x3)WorldView); //v.vPosition
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	float3 VertexNormal = mul( v.vNormal, WorldMatrix );

	float3 direction = normalize( LightDirection );
	Out.vTexCoord0.xy = v.vTexCoord;
	Out.vTexCoord0.z = (max( dot( VertexNormal, -direction ), 0.5f ) * 1.3) - 0.3;
	Out.vTexCoord1  = v.vTexCoord;

	Out.vProvinceIndexCoord = v.vProvinceIndexCoord;

	float4 WorldPosition = mul( v.vPosition, AbsoluteWorldMatrix );
	Out.vColorTexCoord.xy = float2( ( WorldPosition.x + X_OFFSET)/2048.0f, (WorldPosition.z + Z_OFFSET)/1024.0f );

	float2 TerrainCoord = WorldPosition.xz;
	TerrainCoord += 0.5;
	TerrainCoord /= 8.0;
	Out.vTerrainTexCoord  = TerrainCoord;

	Out.vBorderTexCoord0 = float2( WorldPosition.x/2048.0f, WorldPosition.z/1024.0f );

	Out.vTexCoord0.w = 0.1 * v.vPosition.y; //height
	Out.General.x = 0.42*saturate(3*mul( float3(0,1,0) , (float4x3)WorldView).y -0.55); //zoom
	return Out;
}


float4 PixelShader_Map2_0( VS_OUTPUT v ) : COLOR
{  //map terrain on terrain mapmode TOT
	float4 BaseColor = tex2D( BaseTexture, v.vTexCoord0 );
	BaseColor.rgb += float3( 0.8, 0.65, 0.4 ) ; 
	BaseColor.rgb = saturate ( BaseColor.rgb * 0.5 + v.vTexCoord0.www ); 
	float4 TerrainColor = tex2D( MapTexture, v.vTerrainTexCoord );
	float4 Color = tex2D( ColorTexture, v.vColorTexCoord );

	float TerrainAlpha = tex2D( TerrainAlphaTexture, v.vTexCoord1 ).a;
	TerrainColor = lerp(1,TerrainColor,TerrainAlpha);
	float4 OutColor = lerp(Color, TerrainColor, v.General.x) * BaseColor;

	float Winter = tex2D( WinterTexture, v.vProvinceIndexCoord ).x;
	float WinterTarget = lerp(1.05, 0.05 + TerrainColor.r, (1-TerrainColor.a) * v.General.x);
	OutColor = lerp(OutColor, WinterTarget, Winter);
	
	OutColor.rgb *= v.vTexCoord0.z;
	OutColor.a = 1;
	OutColor.rgb += Color.a*2;

	// Terra incognita
	
	return OutColor;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////


VS_OUTPUT_BEACH VertexShader_Beach(const VS_INPUT_BEACH v )
{  //test8 not sure
	VS_OUTPUT_BEACH Out = (VS_OUTPUT_BEACH)0;

	float4 pos = v.vPosition;
	pos.y =min(pos.y, 0.29);

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul(pos, (float4x3)WorldView);
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	float3 VertexNormal = mul( v.vNormal, WorldMatrix );

	float3 direction = normalize( LightDirection );
	Out.vLightIntensity.xy = (max( dot( VertexNormal, -direction ), 0.5f )*1.3)-0.3;
	Out.vLightIntensity.z = 0.1*v.vPosition.y;

	Out.vProvinceIndexCoord = v.vProvinceIndexCoord;

	float4 WorldPosition = mul( v.vPosition, AbsoluteWorldMatrix );
	Out.vColorTexCoord.xy = float2( ( WorldPosition.x + X_OFFSET )/2048.0f, (WorldPosition.z + Z_OFFSET)/1024.0f );

	float2 TerrainCoord = WorldPosition.xz;
	TerrainCoord += 0.5;
	TerrainCoord /= 8.0;
	Out.vTexCoordBase  = TerrainCoord;

	Out.vBorderTexCoord0 = float2( WorldPosition.x/2048.0f, WorldPosition.z/1024.0f );
	Out.vLightIntensity.y = 0.42*saturate(3*mul( float3(0,1,0) , (float4x3)WorldView).y -0.55); //zoom

	return Out;
}

float4 PixelShader_Beach( VS_OUTPUT_BEACH v ) : COLOR
{  //test9 not sure
	float4 BaseColor = tex2D( BaseTexture, v.vTexCoordBase );
	BaseColor.rgb += float3( 0.8, 0.65, 0.4 ) ; 
	BaseColor.rgb = saturate ( BaseColor.rgb * 0.5 + v.vLightIntensity.zzz ); 
	float4 Color = tex2D( ColorTexture, v.vColorTexCoord );
	
	float4 OutColor = lerp(Color, 1, v.vLightIntensity.y) *BaseColor;

	float Winter = tex2D( WinterTexture, v.vProvinceIndexCoord ).x;
	OutColor = lerp(OutColor, 1.05, Winter);


	OutColor.rgb *= v.vLightIntensity.x;

	// Terra incognita

	OutColor.a = 1.0;

	return OutColor;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
//test10 PTI texture

VS_OUTPUT_PTI VertexShader_PTI(const VS_INPUT_PTI v )
{
	VS_OUTPUT_PTI Out = (VS_OUTPUT_PTI)0;
	
  	float4 pos = v.vPosition;
	pos.y = 0.275;

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul(pos, (float4x3)WorldView);
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	return Out;
}

float4 PixelShader_PTI( VS_OUTPUT_PTI v ) : COLOR
{
	return float4( 0.5, 0.5, 0.5, 1.0 );
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT_TREE VertexShader_TREE(const VS_INPUT_TREE v )
{ //trees
	VS_OUTPUT_TREE Out = (VS_OUTPUT_TREE)0;
	
	float4 pos = v.vPosition; //gets rid of trees
	pos.y = 0.275;  //gets rid of trees

	float4x4 WorldView = mul(WorldMatrix, ViewMatrix);
	float3 P = mul(pos, (float4x3)WorldView); //gets rid of trees
	Out.vPosition  = mul(float4(P, 1), ProjectionMatrix);

	return Out;
}

float4 PixelShader_TREE( VS_OUTPUT_TREE v ) : COLOR
{
	float4 OutColor = tex2D( TreeTexture, v.vTexCoord );

	OutColor.a *= vAlpha;

	return OutColor;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

technique TerrainShader_Graphical
{
	pass p0
	{
		VertexShader = compile vs_1_1 VertexShader_Map();
		PixelShader = compile ps_2_0 PixelShader_Map2_0();
	}
}

technique TerrainShader_General
{
	pass p0
	{
		VertexShader = compile vs_1_1 VertexShader_Map_General();
		PixelShader = compile ps_2_0 PixelShader_Map2_0_General();
	}
}

technique TerrainShader_Border
{
	pass p0
	{
		VertexShader = compile vs_1_1 VertexShader_Map_Border();
		PixelShader = compile ps_2_0 PixelShader_Map2_0_Border();
	}
}


technique BeachShader_Graphical
{
	pass p0
	{
		VertexShader = compile vs_1_1 VertexShader_Beach();
		PixelShader = compile ps_2_0 PixelShader_Beach();
	}
}


technique BeachShader_General
{
	pass p0
	{
		VertexShader = compile vs_1_1 VertexShader_Beach_General();
		PixelShader = compile ps_2_0 PixelShader_Beach_General();
	}
}


technique PTIShader
{
	pass p0
	{
		fvf = XYZ;

		LightEnable[0] = false;
		Lighting = False;

		ALPHABLENDENABLE = True;

		ColorOp[0] = Modulate;
		ColorArg1[0] = Texture;
		ColorArg2[0] = current;
  
		ColorOp[1] = Disable;
		AlphaOp[1] = Disable;

		VertexShader = compile vs_1_1 VertexShader_PTI();
		PixelShader = compile ps_1_1 PixelShader_PTI();
	}
}

technique TreeShader
{
	pass p0
	{
		ALPHABLENDENABLE = True;
		ALPHATESTENABLE = True;

		VertexShader = compile vs_1_1 VertexShader_TREE();
		PixelShader = compile ps_2_0 PixelShader_TREE();
	}
}
