#define CLEAR float4(0.1, 0.1, 0.1, 0.3)
#define BLACK float4(0.0,0.0,0.0,1.0)
#define BLUE float4(0.0,0.2,0.5,1.0)
#define TAN float4(0.85,0.7, 0.4, 1.0)
//float4(0.9, 0.83, 0.6, 1.0)
#define DUST float4(0.85,0.7,0.4, 1.0)

texture tex0 < string name = "Base.tga"; >;	// Base texture
texture tex1 < string name = "Base.tga"; >;	// Base texture
texture tex2 < string name = "Base.tga"; >;	// Base texture
texture tex3 < string name = "Base.tga"; >;	// Base texture
texture tex4 < string name = "Base.tga"; >;	// Base texture

float4x4 WorldViewProjectionMatrix; 

float3	LightPosition;
float3	CameraPosition;
float	Time;
float	vAlpha;

sampler BaseTexture  =
sampler_state
{
    Texture = <tex0>;
    MinFilter = Linear; //Point;
    MagFilter = Point;
    MipFilter = Linear;
    AddressU = Wrap;
    AddressV = Wrap;
//    AddressW = Wrap;
};



sampler TheBackgroundTexture  =
sampler_state
{
    Texture = <tex1>;
    MinFilter = Linear; //Point;
    MagFilter = Point;
    MipFilter = Linear;
    AddressU = Wrap;
    AddressV = Wrap;
};


sampler TerraIncognitaFiltered  =
sampler_state
{
    Texture = <tex2>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler WorldColorTex  =
sampler_state
{
    Texture = <tex3>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler NormalMap  =   //water.dds
sampler_state
{
    Texture = <tex4>;
    MinFilter = Linear; //Point;
    MagFilter = Linear; //Point; //n
    MipFilter = Linear;
    AddressU = Wrap;
    AddressV = Wrap;
};


struct VS_INPUT_WATER
{
    float3 position				: POSITION;
    float4 texCoord0			: TEXCOORD0;
    float4 texCoord1			: TEXCOORD1;
};

struct VS_OUTPUT_WATER
{
    float4 position		: POSITION;
    float4 texCoord0		: TEXCOORD0;

    float3 eyeDirection		: TEXCOORD1;
    float3 lightDirection	: TEXCOORD2;
    //float3 halfAngleDirection	: TEXCOORD3;
    float4 WorldTexture		: TEXCOORD3;
};

const float3 offY = float3(0.11, 0.74, 0.43);
const float3 offZ = float3(0.47, 0.19, 0.78);

const float2 off = float2(0.25/1024, 0.25/512);
const float2 offx = float2(0.75/1024, 0.0);
const float2 offy = float2(0.0, 0.75/512);

////////////////////////////////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT_WATER VertexShader_Water_2_0(const VS_INPUT_WATER IN )
{
   	VS_OUTPUT_WATER OUT = (VS_OUTPUT_WATER)0;
   	float4 position = mul( float4(IN.position.xyz , 1.0) , WorldViewProjectionMatrix );
  	 OUT.position = position;
   	 OUT.texCoord0 = IN.texCoord0; // * 2;

   	OUT.WorldTexture.xy = IN.texCoord1.xy + off;

// custom flatmap stuff

	float4 tangent = float4(1.0, 0.0, 0.0, 0.0);
	float4 normal = float4(0.0, 1.0, 0.0, 0.0);
	float4 biTangent = float4(0.0, 0.0, 1.0, 0.0);

   	float4 viewDir = float4( CameraPosition, 0 ) - position;
	// float4 viewDir = float4(0.0,0.0,-1000.0,0.0)-position;
   	OUT.eyeDirection.x = dot( viewDir, mul(tangent,WorldViewProjectionMatrix) );
	OUT.eyeDirection.y = dot( viewDir, mul(normal,WorldViewProjectionMatrix) );
	OUT.eyeDirection.z = dot( viewDir, mul(biTangent,WorldViewProjectionMatrix) );
  	// viewDir.xyz = OUT.eyeDirection.xyz;
   
	OUT.eyeDirection = viewDir.xyz;

	float4 lightDir;
	lightDir.xyz = position - LightPosition;
	lightDir.w = 0;

	OUT.lightDirection = normalize(float3(0.0,0.0,-1.0));
	// mul(lightDir, WorldViewProjectionMatrix).xyz;
    
   	return OUT;
}


float4 PixelShader_Water_2_0( VS_OUTPUT_WATER IN ) : COLOR
{
  	float4 WorldColor = tex2D( WorldColorTex, IN.WorldTexture );

	float4 noise = tex2D(BaseTexture, IN.texCoord0.xy);
//	float4 normalTexture = tex2D(NormalMap, IN.texCoord0.xy); 
	float4 normalTexture = tex2D(TheBackgroundTexture, IN.texCoord0.xy);
	
/*
	float3 normal =normalTexture.xyz * 2.0 - 1.0;
 	float3 lightReflection = reflect(-IN.lightDirection.xyz, normal);
	//lightReflection = normalize( lightReflection );

	//float diff = dot( normal, -lightReflection );

	float3 localView = normalize( IN.eyeDirection.xyz );		
	float spec = max(0.0, dot(lightReflection, localView) );

	spec = pow(spec, 2);  */
	
	WorldColor.b *= 0.8 + 0.8*noise.r;
	
	float4 OutColor = BLACK;
	 
	// 0.15 -- 0.2 is clear -- black
	if (WorldColor.b < 0.2) OutColor = lerp(CLEAR, BLACK, saturate(20*(WorldColor.b - 0.15)) );
	
	// 0.35 -- 0.4 is black -- pattern
	if (WorldColor.b > 0.35) {
				OutColor = lerp(BLACK, BLUE, saturate(20*(WorldColor.b - 0.35)) ); 
	   		OutColor.a = 1.0;
	   		}
	   	
	float TerraIncognita = tex2D( TerraIncognitaFiltered, IN.WorldTexture).g; 
  	float plaster = tex2D( WorldColorTex, 29*IN.WorldTexture ).g;

 	OutColor.rgb = lerp(OutColor.rgb, noise.aaa, 0.2);

	//  float4 paint = lerp(OutColor, spec, 0.15 + 0.15*(1-OutColor.a));
	//  paint.a = OutColor.a;

	float4 paint = OutColor;
 
  	float4 heavydust = float4(DUST.rgb * (1.0*noise.aaa), 1.0); //(1.4*noise.aaa) controls FOW TI PTI brightness
  	float4 unpainted = lerp(OutColor, heavydust, 0.1+0.4*plaster + 0.65*(1-noise.a));
 	OutColor = lerp(paint, unpainted, saturate (0.05+0.6*saturate(2*plaster-1.0)  //dust on cleaned surface
		+ saturate(20*(0.05-TerraIncognita*plaster))  ));

  	float local = saturate(tex2D( TerraIncognitaFiltered, IN.WorldTexture + offx).g -0.25)+
  	saturate(tex2D( TerraIncognitaFiltered, IN.WorldTexture - offx).g -0.25)+
  	saturate(tex2D( TerraIncognitaFiltered, IN.WorldTexture + offy).g -0.25)+
  	saturate(tex2D( TerraIncognitaFiltered, IN.WorldTexture - offy).g -0.25)+
  	saturate(TerraIncognita-0.25);
	OutColor = lerp(OutColor, float4(lerp(0.85*heavydust.rgb, 0.9, 0.35), 1.0), saturate(local*3));

 	return OutColor;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT_WATER VertexShader_Water_1_1(const VS_INPUT_WATER IN )
{  //same as TOT
    	VS_OUTPUT_WATER OUT = (VS_OUTPUT_WATER)0;
    	float4 position = mul( float4(IN.position.xyz , 1.0) , WorldViewProjectionMatrix );
    	OUT.position = position;

    	OUT.texCoord0 = float4 (IN.texCoord1 + off,0,0);
    
  	// OUT.WorldTexture = float4 (IN.texCoord1 + off,0,0);

    	return OUT;
}

float4 PixelShader_Water_1_1( VS_OUTPUT_WATER IN ) : COLOR
{
 	float4 OutColor = float4(0.75, 0.75, 1.0, 1); //slightly higher than TOT

    	//float4 WorldColor = tex2D( WorldColorTex, IN.WorldTexture.xy  );

  	//OutColor.rgb = lerp(OutColor, float3(0.22, 0.22, 0.4), WorldColor.r);
		
	OutColor.rgb += tex2D( TerraIncognitaFiltered, IN.texCoord0.xy ).g - 0.25;
     

	//OutColor += WorldColor.b;
	return OutColor;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////

technique WaterShader_2_0
{
	pass p0
	{
		ALPHABLENDENABLE = True;
		ALPHATESTENABLE = True;

		VertexShader = compile vs_2_0 VertexShader_Water_2_0();
		PixelShader = compile ps_2_0 PixelShader_Water_2_0();
	}
}

technique WaterShader_1_1
{
	pass p0
	{
		ALPHABLENDENABLE = True;

		VertexShader = compile vs_1_1 VertexShader_Water_1_1();
		PixelShader = compile ps_1_1 PixelShader_Water_1_1();
	}
}
